<?php

/*
 *********************************************************************
 *  DEMO VERSION NOTICE:
 *  The demo version of this product contains a static barcode that may be
 *  used for evaluation purposes only. The static barcode cannot be
 *  changed because this would reveal the complete script, which is only
 *  available in the licensed version. The licensed version is provided 
 *  with a money back satisfaction guarantee. if it is necessary to 
 *  test dynamic barcodes with this product, the licensed version is required.
 *  
 *  Order: http://www.idautomation.com/barcode-components/php-generator-script/
 *  
 *  IDAutomation Native PHP Barcode Generator Version 2017
 *  Copyright, IDAutomation.com, Inc. All rights reserved.
 **********************************************************************
 */

// URL params
// ----------
// D    (string)   data to encode 
// V    (integer)  minimum version, default 1, range [-3 .. 40], -3 = M1, -2 = M2, -1 = M3, 0 = M4
// MODE (char)     encoding, default "B", range ["B", "A", "N", "X"], "B" binary, "A" Alpha-num, "N" numeric, "X" best encoding
// ECL  (char)     error level, default "M", range ["M", "L", "Q", "H"]
// PT   (boolean)  apply tilde, default "T", range ["T", "F"]
// Q    (integer)  quiet zone, default 1, range [0 .. n]
// PM   (boolean)  best mask, default "T", range ["T", "F"]
// O    (integer)  orientation, default 0, range [0, 90, 180, 270]
// X    (integer)  zoom factor, default 3, range [1 .. n]

$Demo = false;
$DemoText = "Generated @ bcgen.com";

function createBarcode() {
  global $gSize, $gDataLen, $gLevel, $gFNC1, $gFNC1_AI, $gEncodingMode, $Alphanum;
  global $gFindBestMask, $gApplyTilde, $gVersion, $gTextData, $gFinal, $gCodeInfo, $gQuietZone, $gOffsetY, $gOffsetX;
  global $DemoText, $Demo;
  global $gMatrix;

  // global variables
  $gQuietZone = 0;                   // size, in module, of Quiet Zone
  $gFinal = array();                 // Barcode array to be returned which is readable by VB.
  // set this variable to true only for making debug of script
  $DebugMode = false;

  $xDim = 3;

  $textWidth = 0;
  $textHeight = 0;

  $height = 23;
  $width = 23;
  $gFinal = array();
  $gFinal[22] = "00000000000000000000000";
  $gFinal[21] = "01111111000010011111110";
  $gFinal[20] = "01000001001011010000010";
  $gFinal[19] = "01011101001010010111010";
  $gFinal[18] = "01011101010110010111010";
  $gFinal[17] = "01011101010100010111010";
  $gFinal[16] = "01000001000111010000010";
  $gFinal[15] = "01111111010101011111110";
  $gFinal[14] = "00000000011100000000000";
  $gFinal[13] = "01110011101001000110000";
  $gFinal[12] = "01111110000000010011010";
  $gFinal[11] = "01110011100011100001100";
  $gFinal[10] = "00000100001100101011100";
  $gFinal[9] = "01000111011000000011100";
  $gFinal[8] = "00000000011000100101000";
  $gFinal[7] = "01111111010001000011100";
  $gFinal[6] = "01000001011000100001110";
  $gFinal[5] = "01011101001110010110000";
  $gFinal[4] = "01011101000000010111100";
  $gFinal[3] = "01011101000001010101110";
  $gFinal[2] = "01000001010010100011000";
  $gFinal[1] = "01111111011010010010100";
  $gFinal[0] = "00000000000000000000000";

  ZoomFactor($height, $width, $xDim, $textHeight, $textWidth);

  if ($DebugMode) {
    echo "<pre>";
    for ($i = 0; $i < $height; $i++) {
      for ($k = 0; $k < $width; $k++) {
        if ($gFinal[$i][$k] == 1) {
          echo "#";
        } else {
          echo " ";
        }
      }
      echo "<br>";
    }
    echo "</pre>";
  } else {
    writeBarcode(GetBMP($height, $width));
  }
}

function GetBMP($SizeY, $SizeX) {
  global $gFinal;

  $height = $SizeY;
  $width = $SizeX;
  $strPad = "";

  // Determine width of rows in the BMP file (padded to 4-byte boundary).
  $intTemp = (floor($width / 8) + (cIf($width % 8 > 0, 1, 0))) % 4;
  if ($intTemp != 0)
    $strPad = str_repeat(chr(0), 4 - $intTemp);

  $strBMP = "BM" .
    chr(0) . chr(0) . chr(0) . chr(0) . chr(0) . chr(0) . chr(0) . chr(0) .
    chr(62) . chr(0) . chr(0) . chr(0) . chr(40) . chr(0) . chr(0) . chr(0) .
    size($width) . chr(0) . chr(0) . size($height) . chr(0) . chr(0) .
    chr(1) . chr(0) . chr(1) . chr(0) . chr(0) . chr(0) . chr(0) . chr(0) . chr(0) . chr(0) . chr(0) . chr(0) . chr(37) . chr(14) . chr(0) .
    chr(0) . chr(37) . chr(14) . chr(0) . chr(0) . chr(0) . chr(0) . chr(0) . chr(0) . chr(0) . chr(0) . chr(0) . chr(0) . chr(255) . chr(255) . chr(255) .
    chr(0) . chr(0) . chr(0) . chr(0) . chr(0);

  for ($y = $SizeY - 1; $y >= 0; $y--) { // for each row
    $pixels = 0;
    $pos = 8;
    $strRow = "";
    for ($x = 0; $x < $SizeX; $x++) { // for each column
      $pos--;
      // draw a single barcode cell
      if ($gFinal[$y][$x] >= 1)
        $pixels = $pixels | pow(2, $pos);
      if ($pos == 0) {
        $strRow .= chr($pixels);
        $pos = 8;
        $pixels = 0;
      }
    }
    if ($pos != 8)
      $strRow .= chr($pixels);

    $strRow .= $strPad;
    $strBMP .= $strRow;
  }

  return $strBMP;
}

function ZoomFactor(&$Height, &$Width, $xDim, $textHeight, $textWidth) {
  global $gFinal;

  $newHeight = $Height * $xDim;
  $newWidth = $Width * $xDim;

  $xOffset = 0;
  if ($textWidth > $newWidth) {
    $textWidth = $textWidth - $newWidth;
    $xOffset = intval($textWidth / 2);
  } else {
    $textWidth = 0;
  }

  $newMatrix = array();
  for ($y = 0; $y < $newHeight + $textHeight; $y++) {
    $newMatrix[$y] = array();
    for ($x = 0; $x < $newWidth + $textWidth; $x++) {
      $newMatrix[$y][$x] = 0;
    }
  }

  for ($y = 0; $y < $newHeight; $y++) {
    for ($x = 0; $x < $newWidth; $x++) {
      $newMatrix[$y][$xOffset + $x] = $gFinal[intval($y / $xDim)][intval($x / $xDim)];
    }
  }

  $gFinal = $newMatrix;
  $Height = $newHeight + $textHeight;
  $Width = $newWidth + $textWidth;
}

function cIf($a, $b, $c) {
  if ($a)
    return $b;
  else
    return $c;
}

function size($length) {

  $length = (double) $length;

  if ($length > 255) {
    if ($length > 65535)
      $length = 65535;

    return chr($length % 256) . chr(floor($length / 256));
  } else {
    return chr($length) . chr(0);
  }
}

function writeBarcode($data) {
  header("Content-Type: image/bmp");
  echo $data;
}

createBarcode();




